/********** CalibrationHistories.h ************************************************************************************\

 $Header$

 REVISION HISTORY
   06/99   Charles Cavanaugh
   09/00   Charles Cavanaugh
   04/02   Debbie Mao
   05/02   Debbie Mao
   06/02   Debbie Mao

 $Log$

\**********************************************************************************************************************/

#if !defined _MOPITT_L1_CALIBRATION_HISTORIES_

  #define _MOPITT_L1_CALIBRATION_HISTORIES_

  #include "CalibrationTrain1History.h"
  #include "CalibrationTrain2History.h"
  #include "CalibrationTrain3History.h"
  #include "CalibrationTrain4History.h"

  class calibration_histories {
    private :
      calibration_train_1_history train1;
      calibration_train_2_history train2;
      calibration_train_3_history train3;
      calibration_train_4_history train4;

    protected :

    public :
      calibration_histories ();
      ~calibration_histories ();

      void GetHotBracketingTimes (mopitt_time const&, mopitt_time&, mopitt_time&, mopitt_time&, mopitt_time&, 
                                  mopitt_time&, mopitt_time&, mopitt_time&, mopitt_time&);
      void GetTrackData (mopitt_time&, 
		 float  [CALIBRATION_CHANNELS][CALIBRATION_PIXELS][CALIBRATION_STATES][CALIBRATION_TERMS],
		 double [CALIBRATION_CHANNELS][CALIBRATION_PACKETPOSITION][CALIBRATION_PIXELS][PMC_SIGNAL_STATES]);
      void GetNoiseData (float [PMC_CHANNELS][CALIBRATION_PIXELS][POSITION_NOISE_STATES][CALIBRATION_PACKETPOSITION]);
      void Read         (mopir_collection const&, processor_parameters const&);
  };

#endif
