/********** EngineeringBench1TelemGroup.h *****************************************************************************\

 $Header$

 REVISION HISTORY
   02/99   Charles Cavanaugh
   06/99   Tom Lauren
   10/99   Charles Cavanaugh

 $Log$

\**********************************************************************************************************************/

#if !defined _MOPITT_L1_ENGINEERING_BENCH1_TELEM_GROUP_

  #define _MOPITT_L1_ENGINEERING_BENCH1_TELEM_GROUP_

  #include "EngineeringDataGroup.h"
  #include "EngineeringDataConstants.h"
  #include "MOPIPFile.h"

  class engineering_bench1_telem_group : public engineering_data_group {
    private :
      static int const TABLE_1_THERMISTOR_1_TEMPERATURE_OFFSET;
      static int const TABLE_1_THERMISTOR_2_TEMPERATURE_OFFSET;
      static int const TABLE_1_THERMISTOR_3_TEMPERATURE_OFFSET;
      static int const TABLE_1_THERMISTOR_4_TEMPERATURE_OFFSET;
      static int const FIELDCOUNT;

      enum engineering_bench1_telem_sensor { TABLE_1_THERMISTOR_1_TEMPERATURE, TABLE_1_THERMISTOR_2_TEMPERATURE,
                                             TABLE_1_THERMISTOR_3_TEMPERATURE, TABLE_1_THERMISTOR_4_TEMPERATURE };

    protected :

    public :
      engineering_bench1_telem_group ();
      ~engineering_bench1_telem_group ();

      void AddBlock       (unsigned char*);
      bool Define         (int32, int32, string const&, string const&);
      void GetSummaryData (int, int, mopip_file const&, float [THERMISTOR_BANKS] [ENGINEERING_STATES], 
                           float [THERMISTOR_BANKS] [ENGINEERING_STATES], 
                           float [ENGINEERING_SUMMARY_VALUES] [ENGINEERING_STATES]);
  };

#endif
