/********** EngineeringTrain4Block4Group.h ****************************************************************************\

 $Header$

 REVISION HISTORY
   02/99   Charles Cavanaugh
   06/99   Tom Lauren
   10/99   Charles Cavanaugh

 $Log$

\**********************************************************************************************************************/

#if !defined _MOPITT_L1_ENGINEERING_TRAIN4_BLOCK4_GROUP_

  #define _MOPITT_L1_ENGINEERING_TRAIN4_BLOCK4_GROUP_

  #include "EngineeringDataGroup.h"
  #include "EngineeringDataConstants.h"
  #include "MOPIPFile.h"

  class engineering_train4_block4_group : public engineering_data_group {
    private :
      static int const MIRROR_4_MOTOR_CURRENT_OFFSET;
      static int const CHOPPER_4_MOTOR_CURRENT_OFFSET;
      static int const LMC_4_MOTOR_CURRENT_OFFSET;
      static int const PMC_2_MOTOR_CURRENT_OFFSET;
      static int const FIELDCOUNT;

      enum engineering_train4_block4_sensor { MIRROR_4_MOTOR_CURRENT, CHOPPER_4_MOTOR_CURRENT, 
                                              LMC_4_MOTOR_CURRENT,    PMC_2_MOTOR_CURRENT };

    protected :

    public :
      engineering_train4_block4_group ();
      ~engineering_train4_block4_group ();

      void AddBlock       (unsigned char*);
      bool Define         (int32, int32, string const&, string const&);
      void GetSummaryData (int, int, mopip_file const&, float [ENGINEERING_SUMMARY_VALUES] [ENGINEERING_STATES]);
  };

#endif
