/********** ThermistorPressureParameter.h *****************************************************************************\

 $Header$

 REVISION HISTORY
   03/98   Charles Cavanaugh
   10/99   Charles Cavanaugh

 $Log$

\**********************************************************************************************************************/

#if !defined _MOPITT_L1_THERMISTOR_PRESSURE_PARAMETER_

  #define _MOPITT_L1_THERMISTOR_PRESSURE_PARAMETER_

  #include "MOPIPParameter.h"

  class thermistor_pressure_parameter : public mopip_parameter {
    private :
      static int const PARAMETER_COUNT;

      short  bits;
      double vH;
      double vO;
      double b;
      double c;
      float  low;
      float  high;

    protected :

    public :
      thermistor_pressure_parameter ();
      ~thermistor_pressure_parameter ();

      void Compute  (float [COMPUTE_TERMS], float [COMPUTE_TERMS], float [COMPUTE_TERMS], float [COMPUTE_TERMS]) const;
      void GetRange (float&, float&) const;
      bool Parse    (string const&);
  };

#endif
